// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VRAS_H_
#define _VRAS_H_  // guard

#include "verilated_heavy.h"
#include "verilated_cov.h"

//==========

class VRAS__Syms;
class VRAS_VerilatedVcd;


//----------

VL_MODULE(VRAS) {
  public:
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(res_n,0,0);
    VL_IN8(lock,0,0);
    VL_IN8(unlock,0,0);
    VL_IN8(in_addr_val,0,0);
    VL_IN8(rd,0,0);
    VL_OUT8(out_addr_val,0,0);
    VL_OUT8(locked,0,0);
    VL_OUT8(ras_write_active,0,0);
    VL_OUT8(empty,0,0);
    VL_OUT8(full,0,0);
    VL_IN(key,31,0);
    VL_IN64(in_addr,47,0);
    VL_OUT64(out_addr,47,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*0:0*/ RAS__DOT__STATE;
    CData/*0:0*/ RAS__DOT__NEXT_STATE;
    CData/*0:0*/ RAS__DOT__RAS_STACK_status;
    CData/*0:0*/ RAS__DOT__RAS_STACK_wr;
    CData/*0:0*/ RAS__DOT__RAS_STACK_rd;
    CData/*0:0*/ RAS__DOT__RAS_STACK_empty;
    CData/*0:0*/ RAS__DOT__RAS_STACK_full;
    CData/*0:0*/ RAS__DOT__DO_IDLE;
    CData/*0:0*/ RAS__DOT__DO_LOCK;
    CData/*0:0*/ RAS__DOT__DO_READ_STACK;
    CData/*0:0*/ RAS__DOT__DO_UNLOCK;
    CData/*0:0*/ RAS__DOT__DO_WRITE_STACK;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT__HEAD;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT__HEAD_PLUS_1;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT__HEAD_MINUS_1;
    IData/*31:0*/ RAS__DOT__RAS_STACK__DOT__i;
    QData/*47:0*/ RAS__DOT__RAS_STACK_wr_data;
    QData/*47:0*/ RAS__DOT__RAS_STACK_rd_data;
    QData/*47:0*/ RAS__DOT__RAS_STACK__DOT__MEMORY[16];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    CData/*0:0*/ RAS__DOT____Vtogcov__clk;
    CData/*0:0*/ RAS__DOT____Vtogcov__res_n;
    CData/*0:0*/ RAS__DOT____Vtogcov__lock;
    CData/*0:0*/ RAS__DOT____Vtogcov__unlock;
    CData/*0:0*/ RAS__DOT____Vtogcov__in_addr_val;
    CData/*0:0*/ RAS__DOT____Vtogcov__rd;
    CData/*0:0*/ RAS__DOT____Vtogcov__out_addr_val;
    CData/*0:0*/ RAS__DOT____Vtogcov__locked;
    CData/*0:0*/ RAS__DOT____Vtogcov__ras_write_active;
    CData/*0:0*/ RAS__DOT____Vtogcov__empty;
    CData/*0:0*/ RAS__DOT____Vtogcov__full;
    CData/*0:0*/ RAS__DOT____Vtogcov__STATE;
    CData/*0:0*/ RAS__DOT____Vtogcov__NEXT_STATE;
    CData/*0:0*/ RAS__DOT____Vtogcov__RAS_STACK_status;
    CData/*0:0*/ RAS__DOT____Vtogcov__RAS_STACK_wr;
    CData/*0:0*/ RAS__DOT____Vtogcov__RAS_STACK_rd;
    CData/*0:0*/ RAS__DOT____Vtogcov__RAS_STACK_empty;
    CData/*0:0*/ RAS__DOT____Vtogcov__RAS_STACK_full;
    CData/*0:0*/ RAS__DOT____Vtogcov__DO_IDLE;
    CData/*0:0*/ RAS__DOT____Vtogcov__DO_LOCK;
    CData/*0:0*/ RAS__DOT____Vtogcov__DO_READ_STACK;
    CData/*0:0*/ RAS__DOT____Vtogcov__DO_UNLOCK;
    CData/*0:0*/ RAS__DOT____Vtogcov__DO_WRITE_STACK;
    CData/*0:0*/ RAS__DOT____Vtogcov__IS_KEY_MATCH;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1;
    CData/*3:0*/ RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1;
    CData/*0:0*/ __Vfunc_RAS__DOT__READ_RAS_STACK__0__read;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__1__Vfuncout;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__2__Vfuncout;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__3__Vfuncout;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__4__Vfuncout;
    CData/*0:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write;
    CData/*0:0*/ __Vclklast__TOP__clk;
    IData/*31:0*/ RAS__DOT____Vtogcov__key;
    QData/*47:0*/ RAS__DOT____Vtogcov__in_addr;
    QData/*47:0*/ RAS__DOT____Vtogcov__out_addr;
    QData/*47:0*/ RAS__DOT____Vtogcov__RAS_STACK_wr_data;
    QData/*47:0*/ RAS__DOT____Vtogcov__RAS_STACK_rd_data;
    QData/*47:0*/ __Vfunc_RAS__DOT__READ_RAS_STACK__0__Vfuncout;
    QData/*47:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write_data;
    QData/*47:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write_data;
    QData/*47:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write_data;
    QData/*47:0*/ __Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write_data;
    QData/*47:0*/ __Vchglast__TOP__RAS__DOT__RAS_STACK_rd_data;
    CData/*0:0*/ __Vm_traceActivity[3];
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    VRAS__Syms* __VlSymsp;  // Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
        const char* hierp, const char* pagep, const char* commentp, const char* linescovp);
  public:
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(VRAS);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    VRAS(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~VRAS();
    /// Trace signals in the model; called by application code
    void trace(VerilatedVcdC* tfp, int levels, int options = 0);
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); eval_end_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(VRAS__Syms* __restrict vlSymsp);
    void _traceDump();void _traceDumpOpen();void _traceDumpClose();public:
    void __Vconfigure(VRAS__Syms* symsp, bool first);
  private:
    static QData _change_request(VRAS__Syms* __restrict vlSymsp);
    static QData _change_request_1(VRAS__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__1(VRAS__Syms* __restrict vlSymsp);
    static void _combo__TOP__6(VRAS__Syms* __restrict vlSymsp);
  private:
    void _configure_coverage(VRAS__Syms* __restrict vlSymsp, bool first) VL_ATTR_COLD;
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(VRAS__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(VRAS__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(VRAS__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__5(VRAS__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__3(VRAS__Syms* __restrict vlSymsp);
    static void _sequent__TOP__4(VRAS__Syms* __restrict vlSymsp);
    static void _settle__TOP__7(VRAS__Syms* __restrict vlSymsp) VL_ATTR_COLD;
  private:
    static void traceChgSub0(void* userp, VerilatedVcd* tracep);
    static void traceChgTop0(void* userp, VerilatedVcd* tracep);
    static void traceCleanup(void* userp, VerilatedVcd* /*unused*/);
    static void traceFullSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceFullTop0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitTop(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    void traceRegister(VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
